/******************************************************************************\
|*                                                                            *|
|*                   Neurotechnologija Finger Matcher VF 5.0                  *|
|*                                                                            *|
|* VFMatcher.h                                                                *|
|* Header file for VFMatcher module                                           *|
|*                                                                            *|
|* Copyright (C) 2005-2006 Neurotechnologija                                  *|
|*                                                                            *|
\******************************************************************************/

#ifndef VF_MATCHER_H_INCLUDED
#define VF_MATCHER_H_INCLUDED

#include "VfmMatchDetails.h"
#include "VFMatcherParams.h"

#ifdef N_CPP
extern "C"
{
#endif

N_DECLARE_HANDLE(HVFMatcher);

NBool N_API VfmIsRegistered(void);
NResult N_API VfmCopyParameters(HVFMatcher hDstMatcher, HVFMatcher hSrcMatcher);

NResult N_API VfmCreate(HVFMatcher * pHMatcher);

void N_API VfmFree(HVFMatcher hMatcher);

NResult N_API VfmReset(HVFMatcher hMatcher);
NResult N_API VfmVerify(HVFMatcher hMatcher, const void * template1, NSizeType template1Size,
	const void * template2, NSizeType template2Size, VfmMatchDetails * * ppMatchDetalis, NInt * pScore);
NResult N_API VfmIdentifyStart(HVFMatcher hMatcher, const void * templ, NSizeType templSize,
	VfmMatchDetails * * ppMatchDetails);
NResult N_API VfmIdentifyNext(HVFMatcher hMatcher, const void * templ, NSizeType templSize,
	VfmMatchDetails * pMatchDetails, NInt * pScore);
NResult N_API VfmIdentifyEnd(HVFMatcher hMatcher);
NResult N_API VfmGetParameter(HVFMatcher hMatcher, NUInt parameterId, void * pValue);
NResult N_API VfmSetParameter(HVFMatcher hMatcher, NUInt parameterId, const void * pValue);

#ifdef N_CPP
}
#endif

#endif // !NF_MATCHER_H_INCLUDED
