/* $Id: AppController.m 9292 2006-09-20 13:30:42Z mindaugas $ */

#include <stdlib.h>
#include <time.h>
#import "AppController.h"

#define SRC_REVISION 9843

#include <pthread.h>

@implementation AppController
// ==== Dedications ====

- (void) applicationWillFinishLaunching: (NSNotification *) not
{
	int ret;
	NSString * title;
	NResult res;
	
	char * VFName;
	char * VFStr;
	int VFNameSize;
	int VFCopyrightSize;
	int VFVerHigh, VFVerLow;
	
	NSWindowController * windowController;
	
	res = VfeCreate(&hExtractor);
	if (res != N_OK)
	{
		[app terminate:self];
	}
	
	VFNameSize = VfeGetParameter(hExtractor, VFEP_NAME, NULL);
	if (VFNameSize <= 0)
	{
		[app terminate:self];
	}
	
	VFCopyrightSize = VfeGetParameter(hExtractor, VFEP_COPYRIGHT, NULL);
	if (VFCopyrightSize <= 0)
	{
		[app terminate:self];
	}
	
	VFStr = (char *)malloc(sizeof(char)*(VFNameSize > VFCopyrightSize ? VFNameSize:VFCopyrightSize));
	
	VfeGetParameter(hExtractor, VFEP_NAME, VFStr);
	VfeGetParameter(hExtractor, VFEP_VERSION_HIGH, &VFVerHigh);
	VfeGetParameter(hExtractor, VFEP_VERSION_LOW, &VFVerLow);

	[self addLog:[NSString stringWithFormat:@"%s (v%u.%u.%u.%u)", VFStr,
		(VFVerHigh >> 16) & 0xFF, VFVerHigh & 0xFFFF,
		(VFVerLow  >> 16) & 0xFF, VFVerLow  & 0xFFFF] retCode:0];
	
	VfeGetParameter(hExtractor, VFEP_COPYRIGHT, VFStr);
	
	[self addLog:[NSString stringWithFormat:@"%s", VFStr] retCode:0];
	
	free(VFStr);
	
	res = VfmCreate(&hMatcher);
	if (res != N_OK)
	{
		[app terminate:self];
	}
	
	VFNameSize = VfmGetParameter(hMatcher, VFMP_NAME, NULL);
	if (VFNameSize <= 0)
	{
		[app terminate:self];
	}
	
	VFCopyrightSize = VfmGetParameter(hMatcher, VFMP_COPYRIGHT, NULL);
	if (VFCopyrightSize <= 0)
	{
		[app terminate:self];
	}
	
	VFStr = (char *)malloc(sizeof(char)*(VFNameSize > VFCopyrightSize ? VFNameSize:VFCopyrightSize));
	
	VfmGetParameter(hMatcher, VFMP_NAME, VFStr);
	VfmGetParameter(hMatcher, VFMP_VERSION_HIGH, &VFVerHigh);
	VfmGetParameter(hMatcher, VFMP_VERSION_LOW, &VFVerLow);

	[self addLog:[NSString stringWithFormat:@"%s (v%u.%u.%u.%u)", VFStr,
		(VFVerHigh >> 16) & 0xFF, VFVerHigh & 0xFFFF,
		(VFVerLow  >> 16) & 0xFF, VFVerLow  & 0xFFFF] retCode:0];
	
	VfmGetParameter(hMatcher, VFMP_COPYRIGHT, VFStr);
	
	[self addLog:[NSString stringWithFormat:@"%s", VFStr] retCode:0];
	
	free(VFStr);
	
	VfeGetMaxTemplateSize(hExtractor, &maxRecordSize);
	
	genRecordsCount = 0;
	genRecord = 0;
	
	title = [NSString stringWithFormat:@"VeriFinger Demo (rev: %d)", SRC_REVISION];
	
	[dBController initDB];
	scanners = NULL;
	continuousScanIsStarted = 0;
	
	[secondScrollView setBorderType:NSGrooveBorder];
	[firstScrollView setBorderType:NSGrooveBorder];
	
	[mainWindow setTitle:title];
	
	[mainWindowController showWindow:self];
	
	[NSThread detachNewThreadSelector:@selector(startMultithreadingMode:) toTarget:self withObject:nil];
}

- (void) startMultithreadingMode:(id)sender
{
	return;
}

- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
	if (threadIsStarted == 1) {
		continuousScanIsStarted = 0;
		while(threadIsStarted)
		{
			continuousScanIsStarted = 0;
		}
	}

	[dBController clearDB];

	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}

	VfeFree(hExtractor);
	VfmFree(hMatcher);
	
	[app stop:self];
}

- (BOOL)windowShouldClose:(id)sender
{
	[app terminate:app];
}

// ==== Logs ====

- (void) addLog:(NSString *)string retCode:(long)ret
{
	struct tm now;
	time_t nowTime;
	NSString * logString;
	
	nowTime = time(NULL);
	localtime_r(&nowTime, &now);
	
	if (ret)
	{
		logString = [NSString stringWithFormat: @"%02d:%02d:%02d %@ (%d).\n",
			now.tm_hour, now.tm_min, now.tm_sec, string, ret];
	}
	else
	{
		logString = [NSString stringWithFormat: @"%02d:%02d:%02d %@.\n",
			now.tm_hour, now.tm_min, now.tm_sec, string];
	}

	NSRange range = NSMakeRange([[logsTextView textStorage] length], 0);
	[[logsTextView textStorage] replaceCharactersInRange:range withString:logString];
	range = NSMakeRange ([[logsTextView textStorage] length], 0);
	[logsTextView scrollRangeToVisible: range];
}

// ==== Bitmap ====

- (NSImage *)filterImage:(NSImage *)srcImage
{
	NSBitmapImageRep *srcImageRep = [NSBitmapImageRep 
		imageRepWithData:[srcImage TIFFRepresentation]];

	int w = [srcImageRep pixelsWide];
	int h = [srcImageRep pixelsHigh];
	int x, y;
	
	NSImage *destImage = [[NSImage alloc] initWithSize:NSMakeSize(w, h)];
       
	NSBitmapImageRep *destImageRep = [[[NSBitmapImageRep alloc] 
		initWithBitmapDataPlanes:NULL
		pixelsWide:w 
		pixelsHigh:h 
		bitsPerSample:8 
		samplesPerPixel:1
		hasAlpha:NO
		isPlanar:NO
		colorSpaceName:NSCalibratedWhiteColorSpace
		bytesPerRow:w 
		bitsPerPixel:8] autorelease];

	unsigned char *srcData = [srcImageRep bitmapData];
	unsigned char *destData = [destImageRep bitmapData];
	unsigned char *p1, *p2;
	int n = [srcImageRep bitsPerPixel] / 8;

	for (y = 0; y < h; y++)
	{
		for (x = 0; x < w; x++)
		{
			p1 = srcData + 3 * (y * w + x);       
			p2 = destData + y * w + x;

			*p2 = (char)rint((*p1 + *(p1 + 1) + *(p1 + 2)) / 3);
		}
	}
	
	[destImage addRepresentation:destImageRep];

	return destImage;
}

- (unsigned char *) getBitmapData:(NSImage *)image width:(int *)w height:(int *)h
{
	NSBitmapImageRep * bitmapImageRep;
	unsigned char * bitmapData;
	unsigned char * img;
	int i, j;
	int bits;
	
	NSImage * fImage;

	bitmapImageRep = [NSBitmapImageRep imageRepWithData:[image TIFFRepresentation]];

	bits = [bitmapImageRep bitsPerPixel];

	if (bits > 8)
	{
		image = [self filterImage:image];
	}	

	bitmapImageRep = [NSBitmapImageRep imageRepWithData:[image TIFFRepresentation]];
		
	[bitmapImageRep setCompression:NSTIFFCompressionNone factor:0];
		
	*w = [bitmapImageRep pixelsWide];
	*h = [bitmapImageRep pixelsHigh];
	
	img = (unsigned char *)malloc((*w)*(*h)*sizeof(char));
	
	bitmapData = [bitmapImageRep bitmapData];

	memcpy(img, bitmapData, (*w)*(*h));

	return img;
}

- (NSImage *) putBitmapData:(unsigned char *)data width:(int)w height:(int)h
{
	NSBitmapImageRep * bitmapImageRep;
	NSImage * image;
	unsigned char * bitmapData;
	
	NFMinutia minutia;
	
	NInt minutiaCount;
	NByte G;
	NResult res;
	int ret;
	
	int i, j;
	int x, y;
	int sw, sh;
	int dx, dy;
	int pos, ppos;
	float scale = 1;
	int crl[] =
	{
		0,3,
		1,3,
		2,2,
		3,1,
		3,0
	};

	scale = [options getResolution]/500.0;

	image = [[NSImage alloc] initWithSize:NSMakeSize(w,h)];
	
	bitmapImageRep = [[[NSBitmapImageRep alloc]
		initWithBitmapDataPlanes:NULL
		pixelsWide:w
		pixelsHigh:h
		bitsPerSample:8
		samplesPerPixel:3
		hasAlpha:NO
		isPlanar:NO
		colorSpaceName:NSCalibratedRGBColorSpace
		bytesPerRow:w*3
		bitsPerPixel:24] autorelease];
	
	bitmapData = [bitmapImageRep bitmapData];
	
	for (i = 0; i<h; i++)
	{
		for (j = 0; j<w; j++)
		{
			bitmapData[(w*i+j)*3] = data[w*i+j];;
			bitmapData[(w*i+j)*3+1] = 255;
			bitmapData[(w*i+j)*3+2] = data[w*i+j];;
		}
	}
	
	res = NFRecordGetMinutiaCount(hRecord, &minutiaCount);
	if (res != N_OK)
	{
		[self addLog:@"NFRecordGetMinutiaCount()" retCode:res];
		return;
	}
	
	for (i = 0; i < minutiaCount; i++)
	{
		res = NFRecordGetMinutia(hRecord, i, &minutia);
		pos =
		(
			(int)(minutia.Y*scale) * w +
			(int)(minutia.X*scale)
		);
		
		for (j = 0; j < 10; j+=2)
		{
			ppos = 3 * (pos + crl[j] * w + crl[j+1]);
			bitmapData[ppos] = 255;
			bitmapData[ppos+1] /= 2;
			bitmapData[ppos+2] = 0;
			ppos = 3 * (pos + crl[j] * w - crl[j+1]);
			bitmapData[ppos] = 255;
			bitmapData[ppos+1] /= 2;
			bitmapData[ppos+2] = 0;
			ppos = 3 * (pos - crl[j] * w + crl[j+1]);
			bitmapData[ppos] = 255;
			bitmapData[ppos+1] /= 2;
			bitmapData[ppos+2] = 0;
			ppos = 3 * (pos - crl[j] * w - crl[j+1]);
			bitmapData[ppos] = 255;
			bitmapData[ppos+1] /= 2;
			bitmapData[ppos+2] = 0;
		}
		
		dx = cos(minutia.Angle * M_PI / 128) * (+10);
		dy = sin(minutia.Angle * M_PI / 128) * (+10);

		if (abs(dx) > abs(dy))
		{
			if (dx < 0)
			{
				for (x = dx; x < 0; x++)
				{
					y = x * dy/dx;
					ppos = 3 * (pos + y*w + x);
					bitmapData[ppos] = 255;
					bitmapData[ppos+1] /= 2;
					bitmapData[ppos+2] = 0;
				}
			}
			else
			{
				for (x = 0; x < dx; x++)
				{
					y = x * dy/dx;
					ppos = 3 * (pos + y*w + x);
					bitmapData[ppos] = 255;
					bitmapData[ppos+1] /= 2;
					bitmapData[ppos+2] = 0;
				}
			}
		}
		else
		{
			if (dy < 0)
			{
				for (y = dy; y < 0; y++)
				{
					x = y * dx/dy;
					ppos = 3 * (pos + y*w + x);
					bitmapData[ppos] = 255;
					bitmapData[ppos+1] /= 2;
					bitmapData[ppos+2] = 0;
				}
			}
			else
			{
				for (y = 0; y < dy; y++)
				{
					x = y * dx/dy;
					ppos = 3 * (pos + y*w + x);
					bitmapData[ppos] = 255;
					bitmapData[ppos+1] /= 2;
					bitmapData[ppos+2] = 0;
				}
			}
		}
	}
	[image addRepresentation:bitmapImageRep];
	return image;
}

// ==== Finger name dialog ====

- (NSString *) getFingerName
{
	if ([options getPrompt] == YES)
	{
		[fingerName setStringValue:@""];
		[app runModalForWindow:fingerNameWindow];
		return [fingerName stringValue];
	}
	else
	{
		return [NSString stringWithFormat:@"%@ %d", [options getFingerID], [dBController getDBSize]];
	}
}

- (IBAction)fingerNameOk:(id)sender
{
	if ([[fingerName stringValue] isEqualToString:@""] == NO)
	{
		[fingerNameWindow close];
		[app stopModal];
	}
}

- (void) findDuplicate:(struct record_t *)rec
{
	NResult res;
	NByte G;
	NInt score;
	
	int ret;
	
	int dBSize;
	int count;
	unsigned char * dBItem;
	NSizeType dBItemSize;
	
	res = NFRecordGetG(hRecord, &G);
	if (res != N_OK)
	{
		[self addLog:@"Error: NFRecordGetG()" retCode:res];
		return;
	}
	
	res = VfmIdentifyStart(hMatcher, rec->data, rec->size, NULL);
	if (res != N_OK)
	{
		[self addLog:@"Error: VfmIdentifyStart()" retCode:res];
		return;
	}
	
	dBSize = [dBController getDBSize];

	if (dBSize)
	{
		if ([options getUseG] == YES)
		{
			res = [dBController goToFirstG:G];
		}
		else
		{
			res = [dBController goToFirst];
		}
	
		dBSize = (dBSize * [options getMatchAtMost] / 100)+1;
	
		while(!res && dBSize--)
		{
			dBItem = [dBController getCurrentDBItemData];
			if (!dBItem)
			{
				continue;
			}
			dBItemSize = [dBController getCurrentDBItemDataSize];
			
			res = VfmIdentifyNext(hMatcher, dBItem, dBItemSize, NULL, &score);
			
			if (res != N_OK)
			{
				[self addLog:@"Error: VfmIdentifyNext()" retCode:res];
				VfmIdentifyEnd(hMatcher);
				return;
			}
		
			if (score > 0)
			{
				[self addLog:[NSString stringWithFormat:@"Duplicate found: \"%@\", similarity: %d",
					[dBController getCurrentDBItemName], score] retCode:0];
			}

			if ([options getUseG] == YES)
			{
				res = [dBController goToNextG];
			}
			else
			{
				res = [dBController goToNext];
			}
		}
	}
	
	res = VfmIdentifyEnd(hMatcher);
 }

// ==== Timer ====

- (void) timerStart
{
	gettimeofday (&timeVal, NULL);
}

-(long) timerEnd
{
	struct timeval end;
	long t;
	
	gettimeofday(&end, NULL);
	
	t = end.tv_usec - timeVal.tv_usec +
		(end.tv_sec - timeVal.tv_sec)*1000000;
	
	return t;
}

// ==== Enroll =====

void * continuousScanWithEnrollSelector(void * args)
{
	NSAutoreleasePool * pool = [NSAutoreleasePool alloc];
	int isFinger, isRunning = 0;
	NSImage * image;
	AppController * appController = (AppController *)args;
	Scanners * scanner = [appController getScanners];
	NSString * logString;

	[pool init];

	[appController setThreadIsStarted:1];

	if ([scanner isInit])
	{
		isRunning = 1;
	}
	
	[appController setContinuousScanIsStarted:1]; 
	
	isFinger = 0;
	image = [scanner readFromScanner];
	while(isRunning) {
		if (![scanner isInit])
		{
			isRunning = 0;
			continue;
		}
	
		if (image)
		{
			if (isFinger == 0)
			{
				[appController addLog:@"Finger down" retCode:0];
				isFinger = 1;
				[appController enroll:image];
			}
		}
		else
		{
			if (isFinger)
			{
				[appController addLog:@"Finger up" retCode:0];
				isFinger = 0;
			}
		}
		image = [scanner readFromScanner];
		
		if ([appController getContinuousScanIsStarted] == 0)
		{
			isRunning = 0;
		}
	}
	
	[appController setContinuousScanIsStarted:0];
	[appController setThreadIsStarted:0];
	
	[pool release];
	
	pthread_exit(0);
}

- (IBAction) continuousScanWithEnroll:(id)sender
{
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (![scanners isInit])
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}
	
	if (continuousScanIsStarted == 0)
	{
		[self addLog:@"Continuous scan started" retCode:0];
		pthread_create(&thread, NULL, (void *)&continuousScanWithEnrollSelector, (void *)self);
	}
}

- (IBAction) enrollFromScanner:(id)sender
{
	NSImage * image;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (!(scanners && [scanners isInit]))
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}
	
	image = [scanners readFromScanner];

	if (image)
	{
		[self enroll:image];
	}
	else
	{
		[self addLog:@"Finger is not scanned" retCode:0]; 
	}
}

- (IBAction)enrollFromFile:(id)sender
{
	NSOpenPanel * openPanel = [NSOpenPanel openPanel];
	NSImage * image;
	
	NSString * filename;

	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if ([openPanel runModalForTypes:nil])
	{
		filename = [openPanel filename];
	}
	else
	{
		[self addLog:@"Enroll file open dialog canceled." retCode:0];
		return;
	}
	
	[self addLog:[NSString stringWithFormat:@"Enroll image file: %@", filename] retCode:0];
		
	image = [[[NSImage alloc] initWithContentsOfFile:filename] autorelease];

	[self enroll:image];
}

- (void) enroll:(NSImage *)image
{
	NSImage * srcImage;
	NSImage * destImage;
	NSString * fingerID;
	
	NResult res;
	NInt minutiaCount;
	NByte G, quality;
	struct record_t rec;
	
	unsigned char * img = NULL;

	int w;
	int h;

	int bits;
	
	long timeInterval;

	[self addLog:@">>> Enroll start >>>" retCode:0];

	srcImage = image;
	
	rec.data = (void *)malloc(maxRecordSize);
	if (rec.data == NULL)
	{
		[self addLog:@"Error: malloc(): record" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		return;
	}
	
	img = [self getBitmapData:srcImage width:&w height:&h];
	
	[firstImage setFrameSize:NSMakeSize(w,h)];
	
	[firstScrollView setHasHorizontalScroller:
		([firstImage frame].size.width > [firstScrollView frame].size.width)];
	[firstScrollView setHasVerticalScroller:
		([firstImage frame].size.height > [firstScrollView frame].size.height)];

	[firstScrollView setDocumentView:firstImage];
	
	[firstImage setImage:srcImage];
	
	[self timerStart];
	
	res = VfeExtract(hExtractor,
					 w, h,
					 w,
					 [options getResolution],
					 [options getResolution],
					 img,
					 nfpUnknown,
					 nfitLiveScanPlain,
					 rec.data,
					 maxRecordSize,
					 &rec.size);
	
	timeInterval = [self timerEnd];
	
	[self addLog:[NSString stringWithFormat:@"Extraction time: %d.%06d sec",
		timeInterval/1000000, timeInterval%1000000] retCode:0];
	
	if (res == N_OK && rec.size == 0)
	{
		[self addLog:@"Error: Low quality of image" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	if (res == N_E_NOT_REGISTERED)
	{
		[self addLog:@"Error: Not registred" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		free(rec.data);
		return;
	}

	if (res != N_OK)
	{
		[self addLog:@"Error: VfeExtract()" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	res = NFRecordCreateFromMemory(rec.data, rec.size, 0, NULL, &hRecord);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't create NFRecord" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	res = NFRecordGetMinutiaCount(hRecord, &minutiaCount);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get minutia from NFRecord" retCode:res];
		[self addLog:@"<<< Enroll end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}

	res = NFRecordGetG(hRecord, &G);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}

	res = NFRecordGetQuality(hRecord, &quality);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}
	
	quality = quality * 100 / 255;
	
	[self addLog:[NSString stringWithFormat:@"G: %d, image quality: %d, size: %d bytes, minutiae count: %d",
		G, quality, rec.size, minutiaCount] retCode:0];
	
	destImage = [self putBitmapData:img width:w height:h];

	[secondImage setFrameSize:NSMakeSize(w,h)];
	
	[secondScrollView setHasHorizontalScroller:
		([secondImage frame].size.width > [secondScrollView frame].size.width)];
	[secondScrollView setHasVerticalScroller:
		([secondImage frame].size.height > [secondScrollView frame].size.height)];

	[secondScrollView setDocumentView:secondImage];

	[secondImage setImage:destImage];
	
	if (minutiaCount < [options getMinutiaCount])
	{
		[self addLog:[NSString stringWithFormat:@"Minutia count to low (%d/%d)",
			[options getMinutiaCount], minutiaCount] retCode:0];
	}
	else {
		if ([options getDuplicates] == YES) {
			[self findDuplicate:&rec]; 
		}
		
		if ([dBController add:[self getFingerName] data:rec.data size:rec.size G:G] < 0)
		{
			[self addLog:@"Cannot add record to DataBase" retCode:-1];
		}
	}

	[self addLog:@"<<< Enroll end <<<" retCode:0];
	[destImage autorelease];
	free(rec.data);
	NFRecordFree(hRecord);
}

// ==== Generalize ====

void * continuousScanWithGeneralizeSelector(void * args)
{
	NSAutoreleasePool * pool = [NSAutoreleasePool alloc];
	int isFinger, isRunning = 0;
	NSImage * image;
	AppController * appController = (AppController *)args;
	Scanners * scanner = [appController getScanners];

	[pool init];

	[appController setThreadIsStarted:1];

	if ([scanner isInit])
	{
		isRunning = 1;
	}
	
	[appController setContinuousScanIsStarted:1]; 
	
	isFinger = 0;
	image = [scanner readFromScanner];
	while(isRunning) {
		if (![scanner isInit])
		{
			isRunning = 0;
			continue;
		}
	
		if (image)
		{
			if (isFinger == 0)
			{
				[appController addLog:@"Finger down" retCode:0];
				isFinger = 1;
				[appController generalize:image];
			}
		}
		else
		{
			if (isFinger)
			{
				[appController addLog:@"Finger up" retCode:0];
				isFinger = 0;
			}
		}
		image = [scanner readFromScanner];
		
		if ([appController getContinuousScanIsStarted] == 0)
		{
			isRunning = 0;
		}
	}
	
	[appController setContinuousScanIsStarted:0];
	[appController setThreadIsStarted:0];
	
	[pool release];
	
	pthread_exit(0);
}

- (IBAction) continuousScanWithGeneralize:(id)sender
{
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if (!(scanners && [scanners isInit]))
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}
	if (continuousScanIsStarted == 0)
	{
		[self addLog:@"Continuous scan started" retCode:0];
		pthread_create(&thread, NULL, (void *)&continuousScanWithGeneralizeSelector, (void *)self);
	}
}

- (IBAction) generalizeFromScanner:(id)sender
{
	NSImage * image;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (![scanners isInit])
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}
	
	image = [scanners readFromScanner];
	
	if (image)
	{
		[self generalize:image];
	}
	else
	{
		[self addLog:@"Finger is not scanned" retCode:0]; 
	}
}

- (IBAction)generalizeFromFile:(id)sender
{
	NSOpenPanel * openPanel = [NSOpenPanel openPanel];
	NSImage * image;
	
	NSString * filename;

	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if ([openPanel runModalForTypes:nil])
	{
		filename = [openPanel filename];
	}
	else
	{
		[self addLog:@"Generalization file open dialog canceled." retCode:0];
		return;
	}
	
	[self addLog:[NSString stringWithFormat:@"Generalization image file: %@", filename] retCode:0];
		
	image = [[[NSImage alloc] initWithContentsOfFile:filename] autorelease];

	[self generalize:image];
}

- (void)generalize:(NSImage *)image
{
	NSImage * srcImage;
	NSImage * destImage;
	NBool lowQuality;
	
	NResult res;
	NInt minutiaCount;
	NByte G, quality;
	NInt base;
	struct record_t rec;
	
	unsigned char * img = NULL;
	
	NSString * fingerID;

	int w;
	int h;

	int bits;
	
	long timeInterval;
	int i;
	
	void * pGenRecords[10];
	NSizeType * genRecordsSizes;
	
	HNFRecord hRec;
	
	if (genRecordsCount == 0)
	{
		genRecordsCount = [options getGenCount];
	}
	
	[self addLog:[NSString stringWithFormat:@">>> Generalize (%d of %d) start >>>",
		genRecord+1, genRecordsCount] retCode:0];
	
	srcImage = image;
	
	rec.data = (void *)malloc(maxRecordSize);
	if (rec.data == NULL)
	{
		[self addLog:@"Error: malloc(): record" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}

	img = [self getBitmapData:srcImage width:&w height:&h];
		
	[firstImage setFrameSize:NSMakeSize(w,h)];
	
	[firstScrollView setHasHorizontalScroller:
		([firstImage frame].size.width > [firstScrollView frame].size.width)];
	[firstScrollView setHasVerticalScroller:
		([firstImage frame].size.height > [firstScrollView frame].size.height)];

	[firstScrollView setDocumentView:firstImage];
	
	[firstImage setImage:srcImage];

	[self timerStart];
	
	res = VfeExtract(hExtractor,
					 w, h,
					 w,
					 [options getResolution],
					 [options getResolution],
					 img,
					 nfpUnknown,
					 nfitLiveScanPlain,
					 rec.data,
					 maxRecordSize,
					 &rec.size);
	
	timeInterval = [self timerEnd];
	
	[self addLog:[NSString stringWithFormat:@"Extraction time: %d.%06d sec",
		timeInterval/1000000, timeInterval%1000000] retCode:0];	
	
	if (res == N_OK && rec.size == 0)
	{
		[self addLog:@"Error: Low quality of image" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}
	
	if (res == N_E_NOT_REGISTERED)
	{
		[self addLog:@"Error: Not registred" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}
	
	if (res != N_OK)
	{
		[self addLog:@"Error: VfeExtract()" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
			for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}

	res = NFRecordCreateFromMemory(rec.data, rec.size, 0, NULL, &hRecord);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't create NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}
	
	res = NFRecordGetMinutiaCount(hRecord, &minutiaCount);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get minutia from NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
		return;
	}

	res = NFRecordGetG(hRecord, &G);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		for (i = 0; i < genRecord; i++)
		{
		free(genRecords[i].data);
		}
		return;
	}
	
	res = NFRecordGetQuality(hRecord, &quality);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
		[self addLog:@"<<< Generalize end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		for (i = 0; i < genRecord; i++)
		{
		free(genRecords[i].data);
		}
		return;
	}
	
	quality = quality * 100 / 255;
	
	[self addLog:[NSString stringWithFormat:@"G: %d, image quality: %d, size: %d bytes, minutiae count: %d",
		G, quality, rec.size, minutiaCount] retCode:0];

	destImage = [self putBitmapData:img width:w height:h];

	[secondImage setFrameSize:NSMakeSize(w,h)];
	
	[secondScrollView setHasHorizontalScroller:
		([secondImage frame].size.width > [secondScrollView frame].size.width)];
	[secondScrollView setHasVerticalScroller:
		([secondImage frame].size.height > [secondScrollView frame].size.height)];

	[secondScrollView setDocumentView:secondImage];

	[secondImage setImage:destImage];

	if (minutiaCount < [options getMinutiaCount])
	{
		[self addLog:[NSString stringWithFormat:@"Minutia count to low (%d/%d)",
			[options getMinutiaCount], minutiaCount] retCode:0];
	}
	else
	{
		genRecords[genRecord].data = rec.data;
		genRecords[genRecord].size = rec.size;
		genRecord++;
	}
	
	[self addLog:[NSString stringWithFormat:@"Image (%d of %d)",
		genRecord, genRecordsCount] retCode:0];  
	
	if (genRecord == genRecordsCount)
	{
		genRecord = 0;
		
		genRecordsSizes = (NSizeType *)malloc(sizeof(NSizeType)*genRecordsCount);
		if ((pGenRecords == NULL) || (genRecordsSizes == NULL))
		{
			[self addLog:@"Error: Malloc()" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			for (i = 0; i <= genRecord; i++)
			{
				free(genRecords[i].data);
			}
			return;
		}
		
		for (i = 0; i < genRecordsCount; i++)
		{
			pGenRecords[i] = genRecords[i].data;
			genRecordsSizes[i] = genRecords[i].size;
		}
		
		[self timerStart];
		
		res = VfeGeneralize(hExtractor, genRecordsCount, (const void **)&pGenRecords, genRecordsSizes, rec.data, maxRecordSize, &rec.size, &base);
	
		timeInterval = [self timerEnd];
		
		genRecordsCount = 0;
		
		[self addLog:[NSString stringWithFormat:@"Generalization time: %d.%06d sec",
			timeInterval/1000000, timeInterval%1000000] retCode:0];	
	
		if (res == N_E_NOT_REGISTERED)
		{
			[self addLog:@"Error: Not registred" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			free(rec.data);
			return;
		}
	
		if (res != N_OK)
		{

			[self addLog:@"Error: VfeGeneralize()" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			return;
		}
		
		[self addLog:[NSString stringWithFormat:@"Generalized tamplate is based on template number: %d",
			base+1] retCode:0];
					
		res = NFRecordCreateFromMemory(rec.data, rec.size, 0, NULL, &hRec);
		if (res != N_OK)
		{
			[self addLog:@"Error: Can't create NFRecord" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			free(rec.data);
			return;
		}
	
		res = NFRecordGetMinutiaCount(hRec, &minutiaCount);
		if (res != N_OK)
		{
			[self addLog:@"Error: Can't get minutia from NFRecord" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			free(rec.data);
			NFRecordFree(hRec);
			return;
		}
	
		res = NFRecordGetG(hRec, &G);
		if (res != N_OK)
		{
			[self addLog:@"Error: Can't get G from NFRecord" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			free(rec.data);
			NFRecordFree(hRec);
			return;
		}

		res = NFRecordGetQuality(hRec, &quality);
		if (res != N_OK)
		{
			[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
			[self addLog:@"<<< Generalize end <<<" retCode:0];
			free(rec.data);
			NFRecordFree(hRec);
			return;
		}

		quality = quality * 100 / 255;
		
		NFRecordFree(hRec);
		
		[self addLog:[NSString stringWithFormat:@"G: %d, image quality: %d, size: %d bytes, minutiae count: %d",
			G, quality, rec.size, minutiaCount] retCode:0];
		
		if (minutiaCount < [options getMinutiaCount])
		{
			[self addLog:[NSString stringWithFormat:@"Minutia count to low (%d/%d)", [options getMinutiaCount], minutiaCount] retCode:0];
		}
		else
		{
			if ([options getDuplicates] == YES)
			{
				[self findDuplicate:&rec];
			}

			if ([dBController add:[self getFingerName] data:rec.data size:rec.size G:G] < 0)
			{
				[self addLog:@"Cannot add record to DataBase" retCode:-1]; 
			}
		}
		
		for (i = 0; i < genRecord; i++)
		{
			free(genRecords[i].data);
		}
	}
	else
	{
		rec.data = NULL;
		rec.size = 0;
	}

	[self addLog:@"<<< Generalize end <<<" retCode:0];

	free(rec.data);
	NFRecordFree(hRecord);
	[destImage autorelease];
}

// ==== Identify ====

void * continuousScanWithIdentifySelector(void * args)
{
	NSAutoreleasePool * pool = [NSAutoreleasePool alloc];
	int isFinger, isRunning = 0;
	NSImage * image;
	AppController * appController = (AppController *)args;
	Scanners * scanner = [appController getScanners];

	[pool init];
	
	[appController setThreadIsStarted:1];

	if ([scanner isInit])
	{
		isRunning = 1;
	}
	
	[appController setContinuousScanIsStarted:1]; 
	
	isFinger = 0;
	image = [scanner readFromScanner];
	while(isRunning) {
		if (![scanner isInit])
		{
			isRunning = 0;
			continue;
		}
	
		if (image)
		{
			if (isFinger == 0)
			{
				[appController addLog:@"Finger down" retCode:0];
				isFinger = 1;
				[appController identify:image];
			}
		}
		else
		{
			if (isFinger)
			{
				[appController addLog:@"Finger up" retCode:0];
				isFinger = 0;
			}
		}
		image = [scanner readFromScanner];
		
		if ([appController getContinuousScanIsStarted] == 0)
		{
			isRunning = 0;
		}
	}
	
	[appController setContinuousScanIsStarted:0];
	[appController setThreadIsStarted:0];
	
	[pool release];
	
	pthread_exit(0);
}

- (IBAction) continuousScanWithIdentify:(id)sender
{
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if (!(scanners && [scanners isInit]))
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}
	if (continuousScanIsStarted == 0)
	{
		[self addLog:@"Continuous scan started" retCode:0];
		pthread_create(&thread, NULL, (void *)&continuousScanWithIdentifySelector, (void *)self);
	}
}

- (IBAction)identifyFromScanner:(id)sender
{
	NSImage * image;

	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if (![scanners isInit])
	{
		[self addLog:@"Scanner not initialized" retCode:0];
		return;
	}

	image = [scanners readFromScanner];
	
	if (image)
	{
		[self identify:image];
	}
	else
	{
		[self addLog:@"Finger is not scanned" retCode:0]; 
	}
}

- (IBAction)identifyFromFile:(id)sender
{
	NSOpenPanel * openPanel = [NSOpenPanel openPanel];
	NSImage * image;
	
	NSString * filename;

	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}

	if ([openPanel runModalForTypes:nil])
	{
		filename = [openPanel filename];
	}
	else
	{
		[self addLog:@"Identification file open dialog canceled." retCode:0];
		return;
	}
	
	[self addLog:[NSString stringWithFormat:@"Indentification image file: %@",
		filename] retCode:0];
		
	image = [[[NSImage alloc] initWithContentsOfFile:filename] autorelease];

	[self identify:image];
}

- (void)identify:(NSImage *)image
{
	NSImage * srcImage;
	NSImage * destImage;
	NBool lowQuality;
	
	NResult res;
	NInt minutiaCount;
	NByte G, quality;
	NInt score;
	struct record_t rec;
	
	unsigned char * img = NULL;
	
	unsigned char * dBItem;
	NSizeType dBItemSize;
	int dBSize;

	int count;

	int w;
	int h;

	int bits;
	
	long timeInterval;

	[self addLog:@">>> Identify start >>>" retCode:0];
	
	srcImage = image;
	
	rec.data = (void *)malloc(maxRecordSize);
	if (rec.data == NULL)
	{
		[self addLog:@"Error : malloc(): record" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		return;
	}

	img = [self getBitmapData:srcImage width:&w height:&h];
	
	[firstImage setFrameSize:NSMakeSize(w,h)];
	
	[firstScrollView setHasHorizontalScroller:
		([firstImage frame].size.width > [firstScrollView frame].size.width)];
	[firstScrollView setHasVerticalScroller:
		([firstImage frame].size.height > [firstScrollView frame].size.height)];

	[firstScrollView setDocumentView:firstImage];
	
	[firstImage setImage:srcImage];
	
	[self timerStart];
	
	res = VfeExtract(hExtractor,
					 w, h,
					 w,
					 [options getResolution],
					 [options getResolution],
					 img,
					 nfpUnknown,
					 nfitLiveScanPlain,
					 rec.data,
					 maxRecordSize,
					 &rec.size);
	
	timeInterval = [self timerEnd];
	
	[self addLog:[NSString stringWithFormat:@"Extraction time: %d.%06d sec",
		timeInterval/1000000, timeInterval%1000000] retCode:0];	
	
	if (res == N_OK && rec.size == 0)
	{
		[self addLog:@"Error: Low quality of image" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	if (res == N_E_NOT_REGISTERED)
	{
		[self addLog:@"Error: Not registred" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		return;
	}

	if (res != N_OK)
	{
		[self addLog:@"Error: VfeExtract()" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	res = NFRecordCreateFromMemory(rec.data, rec.size, 0, NULL, &hRecord);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't create NFRecord" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		return;
	}
	
	res = NFRecordGetMinutiaCount(hRecord, &minutiaCount);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get minutia from NFRecord" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		NFRecordFree(hRecord);
		free(rec.data);
		return;
	}
	
	res = NFRecordGetG(hRecord, &G);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get G from NFRecord" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		NFRecordFree(hRecord);
		free(rec.data);
		return;
	}
	
	res = NFRecordGetQuality(hRecord, &quality);
	if (res != N_OK)
	{
		[self addLog:@"Error: Can't get quality from NFRecord" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}
	
	quality = quality * 100 / 255;
	
	[self addLog:[NSString stringWithFormat:@"G: %d, image quality: %d, size: %d bytes, minutiae count: %d",
		G, quality, rec.size, minutiaCount] retCode:0];
	
	destImage = [self putBitmapData:img width:w height:h];

	[secondImage setFrameSize:NSMakeSize(w,h)];
	
	[secondScrollView setHasHorizontalScroller:
		([secondImage frame].size.width > [secondScrollView frame].size.width)];
	[secondScrollView setHasVerticalScroller:
		([secondImage frame].size.height > [secondScrollView frame].size.height)];

	[secondScrollView setDocumentView:secondImage];

	[secondImage setImage:destImage];
	
	if (minutiaCount < [options getMinutiaCount])
	{
		[self addLog:[NSString stringWithFormat:@"Minutia count to low (%d/%d)",
			[options getMinutiaCount], minutiaCount] retCode:0];
	}
	
	res = VfmIdentifyStart(hMatcher, rec.data, rec.size, NULL);
	if (res != N_OK)
	{
		[self addLog:@"Error: VfmIdentifyStart()" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}
	
	dBSize = [dBController getDBSize];
	count = 0;
	timeInterval = 0;
	if (!dBSize)
	{
		[self addLog:@"DataBase is emplty" retCode:0];
	}
	else
	{
		if ([options getUseG] == YES)
		{
			res = [dBController goToFirstG:G];
		}
		else
		{
			res = [dBController goToFirst];
		}
	
		dBSize = (dBSize * [options getMatchAtMost] / 100)+1;
	
		while(!res && dBSize--)
		{
			dBItem = [dBController getCurrentDBItemData];
			if (!dBItem)
			{
				[self addLog:@"DataBase record empty" retCode:0];
				continue;
			}
			dBItemSize = [dBController getCurrentDBItemDataSize];
			
			[self timerStart];
			res = VfmIdentifyNext(hMatcher, dBItem, dBItemSize, NULL, &score);
			timeInterval =+ [self timerEnd];
			count++;
			
			if (res != N_OK)
			{
				VfmIdentifyEnd(hMatcher);
				[self addLog:@"Error: VfmIdentifyNext()" retCode:res];
				[self addLog:@"<<< Identify end <<<" retCode:0];
				free(rec.data);
				NFRecordFree(hRecord);
				return;				
			}
			
			if ((score > 0)||(([options getShowAllResults] == YES)))
			{
				[self addLog:[NSString stringWithFormat:@"Record \"%@\" identified: %@, similarity: %d",
					[dBController getCurrentDBItemName], (score > 0)?@"YES":@"NO", score] retCode:0];
			}
			if ((score > 0)&&(!([options getMatchAllDB] == YES)))
			{
				break;
			}
			if ([options getUseG] == YES)
			{
				res = [dBController goToNextG];
			}
			else
			{
				res = [dBController goToNext];
			}
		}
	}
	
	res = VfmIdentifyEnd(hMatcher);
	if (res != N_OK)
	{
		[self addLog:@"Identification end failed" retCode:res];
		[self addLog:@"<<< Identify end <<<" retCode:0];
		free(rec.data);
		NFRecordFree(hRecord);
		return;
	}
	
	if (count)
	{
		[self addLog:[NSString stringWithFormat:@"Matching time: %d.%06d sec., matched: %d, DataBase size: %d",
			timeInterval/1000000, timeInterval%1000000, count, [dBController getDBSize]] retCode:0];
		[self addLog:[NSString stringWithFormat:@"Effective matching speed: %d fingerprints per second",
			((1000000 * count) / timeInterval)] retCode:0];
	}
	
	[self addLog:@"<<< Identify end <<<" retCode:0];

	free(rec.data);
	NFRecordFree(hRecord);
	[destImage autorelease];
}

- (IBAction) continuousScanStop:(id)sender
{
	if (continuousScanIsStarted)
	{
		continuousScanIsStarted = 0;
		[self addLog:@"Continuous scan stoped" retCode:0];
	}
	else
	{
		[self addLog:@"Continuous scan is not started" retCode:0];
	}
}

// ===== Select Scanner =====

- (IBAction)selectAES4000:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:0];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0]; 
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret]; 
	}
}

- (IBAction)selectAF_S2:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:1];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0]; 
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret]; 
	}
}

- (IBAction)selectMBF200:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:2];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0]; 
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret]; 
	}
}

- (IBAction)selectMBF200old:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:3];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0]; 
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret]; 
	}
}

- (IBAction)selectFM200:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:4];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0]; 
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret]; 
	}
}

- (IBAction)selectSHIMIZU:(id)sender
{
	int ret;
	
	if (continuousScanIsStarted)
	{
		[self addLog:@"Continuous scan is started" retCode:0];
		return;
	}
	
	if (scanners)
	{
		[scanners closeScanner];
		[scanners release];
	}
	scanners = [Scanners alloc];
	[scanners init:5];
	ret = [scanners initScanner];

	if (ret == 0)
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is initialized",
			[scanners getScannerName]] retCode:0];
	}
	else
	{
		[self addLog:[NSString stringWithFormat:@"Scanner \"%@\" is not initialized",
			[scanners getScannerName]] retCode:ret];
	}
}

// ===== DB =====

- (IBAction)clearDB:(id)sender
{
	[dBController clearDB];
	[self addLog:@"DataBase cleared" retCode:0];
}

- (IBAction)openDB:(id)sender
{
	int ret;
	NSString * filename;
	NSOpenPanel * openPanel = [NSOpenPanel openPanel];
	
	if ([openPanel runModalForTypes:nil])
	{
		filename = [openPanel filename];
	}
	else
	{
		[self addLog:@"DataBase file open dialog canceled." retCode:0];
		return;
	}	
	if ((ret = [dBController loadFromFile:filename]) < 0)
	{
		[self addLog:[NSString stringWithFormat:@"DataBase not loaded from file: %@", filename] retCode:ret];
		return;
	}
	
	[self addLog:[NSString stringWithFormat:@"DataBase loaded from file: %@", filename] retCode:ret];
}

- (IBAction)saveDB:(id)sender
{
	int ret;
	NSString * filename;
	NSSavePanel * savePanel = [NSSavePanel savePanel];
	
	if ([savePanel runModal])
	{
		filename = [savePanel filename];
	}
	else
	{
		[self addLog:@"DataBase file save dialog canceled." retCode:0];
		return;
	}
	
	if ((ret = [dBController saveToFile:filename]) < 0)
	{
		[self addLog:[NSString stringWithFormat:@"DataBase not saved to file: %@", filename] retCode:ret];
		return;
	}

	[self addLog:[NSString stringWithFormat:@"DataBase saved to file: %@", filename] retCode:ret];
}

// =========

- (int) getContinuousScanIsStarted
{
	return continuousScanIsStarted;
}

- (void) setContinuousScanIsStarted:(int) value
{
	continuousScanIsStarted = value;
}

- (int) getThreadIsStarted
{
	return threadIsStarted;
}

- (void) setThreadIsStarted:(int) value
{
	threadIsStarted = value;
}

- (Scanners *) getScanners
{
	return scanners;
}

- (HVFExtractor)getHExtractor
{
	return hExtractor;
}

- (HVFMatcher)getHMatcher
{
	return hMatcher;
}

@end
