#pragma once

class CVFImage
{
public:
	BYTE * bits;
private:
	int width;
	int height;
	DWORD size;


	void CheckPixelIndex(int x, int y)
	{
		if (x < 0 || x >= width || y < 0 || y >= height) {
			AfxMessageBox("Pixel index out of bounds");
			AfxThrowUserException();
		}
	}

public:
	CVFImage();
	CVFImage(int width, int height);
	~CVFImage();

	bool IsEmpty() { return bits == NULL; }
	void Clear();

	BYTE *Bits() { return bits; }
	int Width() { return width; }
	int Height() { return height; }
	void SetWidth(int value) { SetSize(value, height); }
	void SetHeight(int value) { SetSize(width, value); }
	void SetSize(int width, int height);

	BYTE GetPixel(int x, int y);
	void SetPixel(int x, int y, BYTE value);

	void Assign(const CVFImage * image);
	void Assign(int width, int height, const BYTE * bits);

	HBITMAP GetBitmap(COLORREF color_min = RGB(0, 0, 0), COLORREF color_max = RGB(255, 255, 255));
	HBITMAP GetBitmap(int bitmapWidth, int bitmapHeight, COLORREF color_min = RGB(0, 0, 0), COLORREF color_max = RGB(255, 255, 255));
};
