Attribute VB_Name = "Bitmaps"
' Bitmap Header Definition
Private Type BITMAP '14 bytes
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Private Type RGBTRIPLE
        rgbtBlue As Byte
        rgbtGreen As Byte
        rgbtRed As Byte
End Type

Private Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

' structures for defining DIBs
Private Type BITMAPCOREHEADER '12 bytes
        bcSize As Long
        bcWidth As Integer
        bcHeight As Integer
        bcPlanes As Integer
        bcBitCount As Integer
End Type

Private Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

' constants for the biCompression field
Const BI_RGB = 0&
Const BI_RLE8 = 1&
Const BI_RLE4 = 2&
Const BI_bitfields = 3&

Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors As RGBQUAD
End Type

Private Type BITMAPCOREINFO
        bmciHeader As BITMAPCOREHEADER
        bmciColors As RGBTRIPLE
End Type

Private Type BITMAPFILEHEADER
        bfType As Integer
        bfSize As Long
        bfReserved1 As Integer
        bfReserved2 As Integer
        bfOffBits As Long
End Type

Public Sub SaveToFile(filename As String, Image As Variant, width As Long, height As Long)

    Open filename For Binary Access Write As #1

    Dim header As BITMAPFILEHEADER
    Dim bheader As BITMAPINFOHEADER

    header.bfType = 19778
    header.bfReserved1 = 0
    header.bfReserved2 = 0
    header.bfSize = 0
    header.bfOffBits = 14 + 40 + 256 * 4

    Put #1, 1, header

    bheader.biSize = 40
    bheader.biWidth = width
    bheader.biHeight = height
    bheader.biPlanes = 1
    bheader.biBitCount = 8
    bheader.biCompression = BI_RGB
    bheader.biSizeImage = 0
    bheader.biXPelsPerMeter = 100
    bheader.biYPelsPerMeter = 100
    bheader.biClrUsed = 0
    bheader.biClrImportant = 0

    Put #1, 14 + 1, bheader

    Dim rgb As RGBQUAD

    Dim i As Long
    For i = 0 To 255
        rgb.rgbBlue = i
        rgb.rgbGreen = i
        rgb.rgbRed = i
        rgb.rgbReserved = 0

        Put #1, 1 + 14 + 40 + i * 4, rgb
    Next i

    Dim b As Byte
    Dim j As Long

    j = 0

    Dim X As Long
    Dim Y As Long
    
    Dim t As Long
    For Y = 1 To height
        For X = 1 To width
            b = Image((height - Y) * width + (X - 1))
            Put #1, 1 + 14 + 40 + 256 * 4 + j, b
            j = j + 1
        Next X

        If width Mod 4 <> 0 Then
            For t = 1 To 4 - (width Mod 4)
                    Put #1, 1 + 14 + 40 + 256 * 4 + j, 0
                    j = j + 1
            Next t
        End If
    Next Y

    Close #1
End Sub

