Attribute VB_Name = "DataBase"
Option Explicit
Option Base 0

Public Const DBFile = "VFDemo.mdb"

Public Const ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & DBFile & ";Persist Security Info=False"
Public Const SQLload = "select * from Fingerprints"
Public Const SQLadd = "select * from Fingerprints where id=-1"
Public Const SQLdelete = "delete from Fingerprints"
Public Const SQLdeleterecord As String = "delete from Fingerprints where id="

Public data(255) As Collection      ' fingerprint data will be stored sorted by "G"
Public count As Long                ' record count

Public Const SEARCH_MODE_FULL = 0
Public Const SEARCH_MODE_FAST = 1

Dim Connection As New ADODB.Connection

Type RaportInfo
    StartTime As Variant
    StopTime As Variant
    RunTime As Variant

    RecordCount As Long
    MatchedRecordCount As Long
    FoundRecordCount As Long
End Type

Dim ri As RaportInfo

Private Sub ClearRaportInfo()
    ri.RunTime = 0

    ri.RecordCount = 0
    ri.MatchedRecordCount = 0
    ri.FoundRecordCount = 0
End Sub

Private Sub CalculateTime(IncreaseMatchedCount As Boolean)
    ri.RunTime = ri.RunTime + (ri.StopTime - ri.StartTime)
    If IncreaseMatchedCount Then ri.MatchedRecordCount = ri.MatchedRecordCount + 1
End Sub

Private Sub PrintRaportInfo()
    MainForm.AddToLog "Fingerprint identification results:"
    MainForm.AddToLog "------------------------------------"
    MainForm.AddToLog "Time: " & CStr(ri.RunTime) & " s"
    MainForm.AddToLog "Found fingerprint count: " & CStr(ri.FoundRecordCount)
    MainForm.AddToLog "DB fingerprint count: " & CStr(ri.RecordCount)
    MainForm.AddToLog "Matched fingerprint count: " & CStr(ri.MatchedRecordCount)
    If ri.RunTime > 0 Then MainForm.AddToLog "Matching speed: " & CStr(ri.MatchedRecordCount / ri.RunTime) & " fingerprints/s"
    If ri.RunTime > 0 Then MainForm.AddToLog "Effective matching speed: " & CStr(ri.RecordCount / ri.RunTime) & " fingerprints/s"
    MainForm.AddToLog "------------------------------------"
End Sub

Public Sub OpenDB()
    Connection.Open ConnectionString
End Sub

Public Sub CloseDB()
    Connection.Close
End Sub

Public Sub DeleteData()
    ClearData

    Connection.Execute SQLdelete
End Sub

Public Sub LoadData()
    ClearData

    Dim Recordset As New ADODB.Recordset

    Recordset.Open SQLload, Connection, adOpenStatic, adLockReadOnly, adCmdText

    Dim record As FingerprintRecord

    count = Recordset.RecordCount

    Dim C As Long
    C = 0
    MainForm.BeginLongProcess
    Do While Not Recordset.EOF
        Set record = New FingerprintRecord
        record.id = Recordset("ID")
        If Recordset("Features").ActualSize > 0 Then

            record.features = Recordset("Features")
            record.FingerID = Recordset("FingerID")

            Dim G As Byte
            G = VFGetG(record.features)

            If data(G) Is Nothing Then
                Set data(G) = New Collection
            End If

            data(G).Add record

            C = C + 1

            If C Mod 500 = 0 Then
                DoEvents
                If count <> 0 Then
                    MainForm.ProgressBar.value = C * 100 / count
                End If
            End If

            If MainForm.StopProcess = True Then
                Exit Do
            End If
        End If

        Recordset.MoveNext

    Loop

    count = C
    MainForm.EndLongProcess

    Recordset.Close
End Sub

Public Sub AddFinger(features As Variant, Size As Long, FingerID As String)
    Dim G As Byte
    G = VFGetG(features)

    Dim D() As Byte ' data
    ReDim D(Size - 1)

    Dim i As Long
    For i = 0 To Size - 1
        D(i) = features(i)
    Next i

    Dim r As New FingerprintRecord

    r.features = D
    r.FingerID = FingerID

    If data(G) Is Nothing Then Set data(G) = New Collection
    data(G).Add r

    count = count + 1

    ' adding to db

    Dim Recordset As New ADODB.Recordset

    Recordset.Open SQLadd, Connection, adOpenStatic, adLockOptimistic, adCmdText

    Recordset.AddNew

    Recordset("Features") = r.features
    Recordset("FingerID") = r.FingerID

    Recordset.Update

    r.id = Recordset("ID")

    MainForm.AddToLog "Fingerprint stored in DB with Id=" & CStr(r.id) & vbNewLine

    Recordset.Close
End Sub

Private Sub IdentifyG(ByRef f As Variant, G As Byte, ByRef found As Boolean, ByRef C As Long, ByVal SilentMode As Boolean)
    Dim j As Long
    Dim md As VFMATCHDETAILS
    Dim ret As Long
    md.Size = VF_MATCHDETAILS_SIZE
    If Not data(G) Is Nothing Then
        For j = 0 To data(G).count - 1
            C = C + 1
            md.similarity = 0
            ri.StartTime = Timer
            VFIdentifyNext data(G).Item(j + 1).features, md, 0
            
            ri.StopTime = Timer
            CalculateTime True

            If md.similarity >= threshold Then
                'If Not SilentMode Then
                MainForm.AddToLog "id:" & CStr(data(G).Item(j + 1).id) & vbTab & "FingerID: " & data(G).Item(j + 1).FingerID & vbTab & " Similiarity: " & CStr(md.similarity) & " Threshold: " & CStr(threshold)
                found = True

                ri.FoundRecordCount = ri.FoundRecordCount + 1
                Exit Sub
            End If
        Next j
    End If

    If count <> 0 Then
        MainForm.ProgressBar.value = C * 100 / count
    End If
    DoEvents
End Sub

Public Sub Identify(f As Variant, Mode As Integer, Optional ByRef found As Boolean, Optional ByVal SilentMode As Boolean = False)
    Dim ret As Long
    Dim G As Byte
    G = VFGetG(f)
    Dim C As Long

    MainForm.BeginLongProcess

    ClearRaportInfo
    ri.RecordCount = count

    ri.StartTime = Timer
    VFIdentifyStart f, 0
    ri.StopTime = Timer
    CalculateTime False

    If Mode = SEARCH_MODE_FAST Then
        'Dim found As Boolean
        Dim Gmin As Byte
        Dim Gmax As Byte
        Dim updir As Boolean

        C = 0
        found = False
        updir = True

        Gmin = G
        Gmax = G

        Do While Not found
            IdentifyG f, G, found, C, SilentMode
            If Not found Then
                If Gmin = 0 And Gmax = 255 Then
                    found = True
                Else
                    If updir And Gmax = 255 Then updir = False
                    If Not updir And Gmin = 0 Then updir = True
                End If

                If Not found Then
                    If updir Then
                        Gmax = Gmax + 1
                        G = Gmax
                    Else
                        Gmin = Gmin - 1
                        G = Gmin
                    End If
                End If
                updir = Not updir
            End If

            If MainForm.StopProcess = True Then
                Exit Do
            End If
        Loop
    Else
        ' SEARCH_MODE_FULL

        Dim md As VFMATCHDETAILS
        md.Size = VF_MATCHDETAILS_SIZE

        Dim i As Long
        Dim j As Long

        If Not SilentMode Then MainForm.AddToLog "Starting matching in full mode..."
        If Not SilentMode Then MainForm.AddToLog ""

        Dim rec As FingerprintRecord

        For i = 0 To 255
            If Not data(i) Is Nothing Then
                For j = 0 To data(i).count - 1
                    C = C + 1
                    md.similarity = 0

                    ri.StartTime = Timer
                    VFIdentifyNext data(i).Item(j + 1).features, md, 0
                    
                    ri.StopTime = Timer
                    CalculateTime True

                    If md.similarity >= threshold Then
                        Set rec = data(i).Item(j + 1)
                        If Not SilentMode Then MainForm.AddToLog "id:" & CStr(rec.id) & vbTab & "FingerID: " & rec.FingerID & vbTab & " Similiarity: " & CStr(md.similarity) & " Threshold: " & CStr(threshold)

                        ri.FoundRecordCount = ri.FoundRecordCount + 1
                    End If
                Next j
            End If

            If count <> 0 Then
                MainForm.ProgressBar.value = C * 100 / count
            End If

            DoEvents

            If MainForm.StopProcess = True Then
                Exit For
            End If
        Next i
    End If
    
    ret = VFIdentifyEnd(0)
    If (VFFailed(ret)) Then
        MsgBox "Function VFIdentifyEnd returned " & CStr(ret) & " " & VFErrorToString(ret), vbCritical, "Error"
        Exit Sub
    End If
    
    MainForm.EndLongProcess
    found = ri.FoundRecordCount > 0
    If Not SilentMode Then PrintRaportInfo
End Sub

Public Sub ClearData()
    Dim i As Long
    Dim j As Long

    Dim C As Long
    C = 0

    MainForm.BeginLongProcess
    For i = 0 To 255
        If Not data(i) Is Nothing Then
            For j = 0 To data(i).count - 1
                data(i).Remove 1
                C = C + 1
            Next j
        End If
        If count <> 0 Then MainForm.ProgressBar.value = C * 100 / count
        DoEvents
    Next i

    count = 0

    MainForm.EndLongProcess
End Sub

Public Sub DeleteRecord(ByVal id As Long)
    Dim j As Integer
    Dim G As Long

    For G = 0 To 255
        If Not data(G) Is Nothing Then
            For j = data(G).count To 1 Step -1
                If data(G).Item(j).id = id Then ' delete
                    data(G).Remove (j)
                End If
            Next j
        End If
    Next G

    Connection.Execute (SQLdeleterecord & CStr(id))
End Sub

