#pragma once

#include "Controls.h"
#include "StdControls.h"

enum FLEFMode { flefmEditEntry = 0, flefmNewEntry, flefmEnroll, flefmIdentify };

class CFileListEntryForm: public CForm
{
private:
	FLEFMode mode;
	bool many_entries, from_scanner, dif_res, dif_fid;
	string source;

	CLabel *label_source, *label_resolution, *label_dpi, *label_fingerid, *label_preview;
	CEdit *edit_source, *edit_resolution, *edit_fingerid;
	CButton *button_ok, *button_cancel, *button_default, *button_help;

	void UpdateMode();
	void UpdateSourceEnabled();
	void UpdateFromScanner();
	void UpdateSource();
	void UpdatePreview();

protected:
	bool OnCloseQuery();
	void OnClose();
	void OnHelp();
	void OnCommand(WORD id, WORD event, CControl *control);

public:
	CFileListEntryForm();

	FLEFMode Mode() { return mode; }
	bool ManyEntries() { return many_entries; }
	bool FromScanner() { return from_scanner; }
	bool DifRes() { return dif_res; }
	bool DifFID() { return dif_fid; }

	void SetDefaults();

	void SetMode(FLEFMode value);
	void SetManyEntries(bool value);
	void SetFromScanner(bool value);
	void SetDifRes(bool value);
	void SetDifFID(bool value);

	const string& Source();
	int Resolution();
	const string& FingerID();
	void SetSource(const string &value);
	void SetResolution(int value);
	void SetFingerID(const string &value);

};

const DWORD FLEB_EDIT_ENTRY		= 0x00000000;
const DWORD FLEB_NEW_ENTRY		= 0x00000001;
const DWORD FLEB_ENROLL			= 0x00000002;
const DWORD FLEB_IDENTIFY		= 0x00000003;
const DWORD FLEB_MODE_MASK		= 0x00000003;
const DWORD FLEB_MANY_ENTRIES	= 0x00000004;
const DWORD FLEB_FROM_SCANNER	= 0x00000008;
const DWORD FLEB_DIF_RES		= 0x00010000;
const DWORD FLEB_DIF_FID		= 0x00020000;

bool FileListEntryBox(CForm * owner, DWORD &flags, string &source, int &resolution, string &finger_id);
