#pragma once

#include "Controls.h"
#include "StdControls.h"
#include "Options.h"

class COptionsForm: public CForm
{
private:
	CCheckBox * checkBoxUseLowQualityImages;

	CLabel * labelFileResolution, * labelFileFingerId;
	CButton * buttonFileEdit;
	CCheckBox * checkBoxFilePrompt;

	CLabel * labelScannerFingerId;
	CButton * buttonScannerEdit;
	CCheckBox * checkBoxScannerPrompt;

	CCheckBox * checkBoxMinimalMinutiaCount;
	CEdit * editMinimalMinutiaCount;
	CCheckBox * checkBoxSearchForDuplicates, * checkBoxWarnDifferentFingerId;

	CCheckBox * checkBoxCheckForEmptyDatabase;
	CCheckBox * checkBoxUseG, * checkBoxMatchAllDatabase, * checkBoxShowAllResults;
	CLabel * labelDatabasePercentPrefix, * labelDatabasePercentSuffix;
	CEdit * editDatabasePercent;

	CButton * buttonOK, * buttonCancel, * buttonDefault;

	void SetDefaultOptions();

	static int GetResolution(CLabel * label)
	{
		return StringToInt(label->Text());
	}

	static void SetResolution(CLabel * label, int value)
	{
		label->SetText(IntToString(value));
	}
	
	static const string & GetFingerId(CLabel * label)
	{
		return label->Text();
	}

	static void SetFingerId(CLabel * label, const string &value)
	{
		label->SetText(value);
	}
	
	void EditInfo(CLabel * labelFingerId, CLabel * labelResolution, bool fromScanner);

	int get_MinimalMinutiaCount() { return StringToInt(editMinimalMinutiaCount->Text()); }
	void set_MinimalMinutiaCount(int value) { editMinimalMinutiaCount->SetText(IntToString(value)); }
	__declspec(property(get = get_MinimalMinutiaCount, put = set_MinimalMinutiaCount)) int MinimalMinutiaCount;
	
	int get_DatabasePercent() { return StringToInt(editDatabasePercent->Text()); }
	void set_DatabasePercent(int value) { editDatabasePercent->SetText(IntToString(value)); }
	__declspec(property(get = get_DatabasePercent, put = set_DatabasePercent)) int DatabasePercent;

	void UpdateMinimalMinutiaCount();
	void UpdateSearchForDuplicates();
	void UpdateUseG();

	void CheckMinimalMinutiaCount();
	void CheckDatabasePercent();

protected:
	void OnCommand(WORD id, WORD event, CControl * control);

	bool OnCloseQuery();

public:
	COptionsForm();

	void GetOptions(VFDemoOptions &value);
	void SetOptions(const VFDemoOptions &value);
};

bool OptionsBox(CForm * owner, VFDemoOptions &options);
