#pragma once

#include "VFingerX.h"

struct VFFileListItem
{
	string filename;
	int resolution;
	string finger_id;

	VFFileListItem()
		: resolution(VF_IMAGE_RESOLUTION)
	{
	}

	VFFileListItem(const string &filename, int resolution = VF_IMAGE_RESOLUTION, const string &finger_id = emptyString)
	{
		Assign(filename, resolution, finger_id);
	}

	VFFileListItem(const VFFileListItem &item)
	{
		Assign(item);
	}

	void Assign(const string &filename, int resolution, const string &finger_id)
	{
		this->filename = filename;
		this->resolution = resolution;
		this->finger_id = finger_id;
	}

	void Assign(const VFFileListItem &item)
	{
		Assign(item.filename, item.resolution, item.finger_id);
	}

};

typedef vector<VFFileListItem> VFFileList;

extern const string defaultFileListFileExtension;
string GetVFFileListFilter();
string GetVFFileListFilterName();
string GetVFFileListFilterString(bool filter_in_name = true);
string GetLoadVFFileListFilterString(bool filter_in_name = true, bool all_files = true);
string GetSaveVFFileListFilterString(bool filter_in_name = true);

bool LoadVFFileList(const string &filename, VFFileList *filelist);
bool SaveVFFileList(const string &filename, VFFileList *filelist);

string GetVFFileListRoot(VFFileList &fileList);

extern const string default_file_finger_id;
extern const string default_scanner_finger_id;

string MakeFingerID(const string &finger_id, const string &source, bool from_scanner);
void CheckFingerID(const string &finger_id, bool from_scanner);

string GetFingerIDHelp(bool from_scanner);
