#pragma once

#include "Controls.h"
#include "StdControls.h"
#include "VFingerX.h"
#include "VFOptions.h"

class CVFOptionsForm: public CForm
{
private:
	CComboBox * comboBoxMode;

	CComboBox * comboBoxReturnedImage;

	CComboBox * comboBoxGeneralizationFar;
	CEdit * editGenMaximalRotation;

	CComboBox * comboBoxMatchingFar;
	CTrackBar * trackBarMatchingSpeed;
	CEdit * editMaximalRotation;

	CButton * buttonOK, * buttonCancel, * buttonDefault;

	static void CreateFarControls(int x, int &y, int w, const string &name, CLabel * &label, CComboBox * &comboBox);
	static void CreateMaximalRotationControls(int x, int &y, int w, const string &name, CLabel * &label, CEdit * &edit);

	void SetDefaultOptions();

	static int GetMatchingThreshold(CComboBox * comboBox)
	{
		return VFFARToMatchingThreshold(StringToFloat(comboBox->Text(), STRING("%")));
	}

	static void SetMatchingThreshold(CComboBox * comboBox, int value)
	{
		comboBox->SetText(FloatToString(VFMatchingThresholdToFAR(value)) + TEXT("%"));
	}

	static int GetMaximalRotation(CEdit * edit)
	{
		return VFDegToDir((float)StringToFloat(edit->Text(), TEXT("")));
	}

	static void SetMaximalRotation(CEdit * edit, int value)
	{
		edit->SetText(FloatToString(VFDirToDegF(value)) + TEXT(""));
	}

	static void CheckFar(CComboBox * comboBox, const string &name);
	static void CheckMaximalRotation(CEdit * edit);

protected:
	void OnCommand(WORD id, WORD event, CControl * control);

	bool OnCloseQuery();

public:
	CVFOptionsForm();

	void GetOptions(VFOptions &value);
	void SetOptions(const VFOptions &value);
};

bool VFOptionsBox(CForm * owner, VFOptions &options, const string &caption);
