package neurotechnologija.utils;
import java.awt.image.RGBImageFilter;

/**
 * Image filter to change image background and foreground colours from "white on black" to
 * "green on white"
 * @see java.awt.image#RGBImageFilter
 *
 * @version 1.0 02/07/2002
 */
public class FeaturesFilter extends RGBImageFilter {

        /**
         * Change image colours.
         * RGB(255, 255, 255) -> RGB(0, 0, 0)<br/>
         * RGB(0, 0, 0) -> RGB(0, 255, 0)
         * @see java.awt.image.RGBImageFilter#filterRGB(int, int, int)
         */
        public int filterRGB(int x, int y, int rgb) {
                if (rgb == 0xffffffff) {
                        rgb = 0;
                }
                else {
                        rgb = 0xff00ff00;
                }
                return rgb;
        }

}

