/********************************************************\
|*                                                      *|
|*                  VeriFinger 5.0 SDK                  *|
|*                                                      *|
|*  VFingerX.h                                          *|
|*    Header file for extended VeriFinger features      *|
|*                                                      *|
|*  Copyright (C) 1998-2006 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

#ifndef __VFINGERX_INCLUDED__
#define __VFINGERX_INCLUDED__

#include "VFinger.h"


////////////////////////
//                    //
// Features functions //
//                    //
////////////////////////

#define VF_MAX_MINUTIA_COUNT 1024

#define VF_MAX_SINGULAR_POINT_COUNT 64

#define VF_BLOCK_SIZE 16
#define VF_MAX_IMAGE_DIMENSION  2048

#define VF_MAX_BLOCKED_ORIENTS_DIMENSION (VF_MAX_IMAGE_DIMENSION / VF_BLOCK_SIZE)

#define VF_MAX_FEATURES_SIZE 10000

struct VFMINUTIAE
{
        int count;
        int x[VF_MAX_MINUTIA_COUNT];
        int y[VF_MAX_MINUTIA_COUNT];
        BYTE d[VF_MAX_MINUTIA_COUNT];
        BYTE c[VF_MAX_MINUTIA_COUNT];
};

struct VFSINGULARPOINTS
{
        int count;
        int x[VF_MAX_SINGULAR_POINT_COUNT];
        int y[VF_MAX_SINGULAR_POINT_COUNT];
        BYTE t[VF_MAX_SINGULAR_POINT_COUNT];
        BYTE d[VF_MAX_SINGULAR_POINT_COUNT];
};

struct VFBLOCKEDORIENTS
{
        int width;
        int height;
        BYTE bits[VF_MAX_BLOCKED_ORIENTS_DIMENSION][VF_MAX_BLOCKED_ORIENTS_DIMENSION];
};

struct VFFEATURES
{
        BYTE g;
        VFMINUTIAE m;
        VFSINGULARPOINTS sp;
        VFBLOCKEDORIENTS bo;
};

DWORD VFDecompressFeatures(const BYTE * features, VFFEATURES * f);
DWORD VFCompressFeatures(const VFFEATURES * f, BYTE * features);

#endif
