/********************************************************\
|*                                                      *|
|*                  VeriFinger 5.0 SDK                  *|
|*                                                      *|
|*  Image.h                                             *|
|*    CImage class declaration                          *|
|*                                                      *|
|*  Copyright (C) 1998-2006 Neurotechnologija           *|
|*                                                      *|
\********************************************************/

#if !defined(AFX_IMAGE_H__F3DE96E5_1ADE_11D4_94C3_000021C2511F__INCLUDED_)
#define AFX_IMAGE_H__F3DE96E5_1ADE_11D4_94C3_000021C2511F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>
#include "2DByteArray.h"

#define t_uint8 unsigned char
#define t_int8 signed char
#define t_uint16 unsigned short
#define t_uint32 unsigned long

typedef struct TIFF_TAG{
                t_uint16  Tag;
                t_uint16  Type;
                t_uint32  Count;
                union {
                                  t_uint8 Byte[4];
                          t_uint16 Short[2];
                                  t_uint32 Long;
                                } Value;
                } Tag;


class CImage
{
public:
        HBITMAP ToHandle(bool green=true);
        HRESULT FromHandle(HBITMAP ibmp);
        HRESULT Copy(CImage * img);
        void Draw(HDC dc, BOOL fGrayScale, float Ratio = 1);
        HRESULT SaveBMP(LPCSTR path);
        HRESULT LoadBMP(LPCSTR fn);
        HRESULT LoadDAT(LPCSTR fn);
        HRESULT LoadTIF(LPCSTR fn);
        int  l;
        int  w;
        C2DByteArray m_img;
        BYTE ** img;
        BITMAPINFO * m_pBMI;
        BITMAPINFO * m_pBMIGn;
        HRESULT Load(LPCSTR filename,float ratio);
        HRESULT SetSize(int x, int y);
        CImage();
        virtual ~CImage();

protected:
        HRESULT GetFileExt(LPCSTR fn,CHAR * ext);

        // for TIFF reader
        int                     m_tiff_byteorder; // 1 - intel; 0 - Mac
        t_uint16        m_tiff_TagsCount;
        Tag*            m_tiff_Tags;
        t_uint32        m_tiff_count;
        t_uint32*       m_tiff_offsets;
        t_uint32*       m_tiff_counts;
        t_uint32*       m_tiff_colormap;
        t_uint32*       m_tiff_bitpersample;

        HRESULT   TIFFReadHeaderAndTags(FILE * file);
        HRESULT   TIFFReadData(FILE * file);
        HRESULT   TIFFReadImage(FILE * file, t_uint32 BitsPerSample, int rgb);
        HRESULT   TIFFReadStipsInfo(FILE * file);
        HRESULT   TIFFReadTilesInfo(FILE * file);
        t_uint16  TIFFGetValueByOrder(t_uint16 value);
        t_uint32  TIFFGetValueByOrder(t_uint32 value);
        t_uint32  TIFFGetTagValue(t_uint16 TagType);
        t_uint32* TIFFGetTagValues(t_uint16 TagType, FILE * file);
        Tag*      TIFFGetTag(t_uint16 TagType);
};

#endif // !defined(AFX_IMAGE_H__F3DE96E5_1ADE_11D4_94C3_000021C2511F__INCLUDED_)
