﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Neurotec.Biometrics.VeriFingerDemo
{
	public class DistributionBuilder
	{
		public DistributionBuilder()
		{
		}

		private List<int> items = new List<int>();

		private int valueCount = 0;

		public int ValueCount
		{
			get
			{
				return valueCount;
			}
		}

		private int min = 0;

		public int Min
		{
			get
			{
				return min;
			}
		}

		public int Max
		{
			get
			{
				return min + items.Count - 1;
			}
		}

		public double CountToProbability(int count)
		{
			return count / (double)valueCount;
		}

		public int GetCount(int value)
		{
			return value < min || value > Max ? 0 : items[value - min];
		}

		public double GetProbability(int value)
		{
			return CountToProbability(GetCount(value));
		}

		public void Add(int value)
		{
			if(valueCount == 0)
			{
				items.Add(1);
				min = value;
			}
			else
			{
				if(value < min)
				{
					int d = min - value;
					int c = items.Count;
					for(int i = 0; i < d; i++)
						items.Add(0);
					for(int i = c - 1; i >= 0; i--)
						items[i + d] = items[i];
					for(int i = 0; i < d; i++)
						items[i] = 0;
					min = value;
				}
				while(value > Max) items.Add(0);
				items[value - min]++;
			}
			valueCount++;
		}

		public Distribution ToDistribution()
		{
			return new Distribution(items, min);
		}
	}
}