#include <stdio.h>
#include "img.h"

int
load_img_file(char *fileName, char **image, int *width, int *height, HNImage *hImg)
{
//	HNImageFormat hFormat;
	HNImage hImage;
	HNImage hGrayscale;
	NResult ret;
//	NSizeType hStride;
	NFloat hres;
	NFloat vres;

/*
	ret = NImagesRegister(REGISTER);
	if (NFailed(ret))
	{
		printf("NImagesRegister() failed %d\n", ret);
		return -1;
	}
*/
	ret = TiffLoadImageFromFile(fileName, &hImage);
	if (NFailed(ret))
	{
		printf("TiffLoadImageFromFile() failed: %d\n", ret);
		return -1;
	}

	ret = NImageGetHorzResolution(hImage, &hres);
	if (NFailed(ret))
	{
		printf("NImageGetHorzResolution() failed %d\n", ret);
		NImageFree(hImage);
		return -1;
	}

	ret = NImageGetVertResolution(hImage, &vres);
	if (NFailed(ret))
	{
		printf("NImageGetHorzResolution() failed %d\n", ret);
		NImageFree(hImage);
		return -1;
	}

	if (hres < 250)
	{
		printf("Bad horizontal resolution %f, overwriting to 500 dpi\n", hres);
		hres = 500;
	}

	if (vres < 250)
	{
		printf("Bad vertical resolution %f, overwriting to 500 dpi\n", vres);
		vres = 500;
	}


	ret = NImageCreateFromImageEx(npfGrayscale, 0, hres, vres, hImage, &hGrayscale);
//	ret = NImageCreateFromImage(npfGrayscale, 0, hImage, &hGrayscale);
	if (NFailed(ret))
	{
		printf("NImageCreateFromImgeEx() failed: %d\n", ret);
		NImageFree(hImage);
		return -1;
	}

	NImageFree(hImage);

	ret = NImageGetHeight(hGrayscale, height);
	if (NFailed(ret))
	{
		printf("NImageGetHeight() failed: %d\n", ret);
		NImageFree(hGrayscale);
		return -1;
	}

	ret = NImageGetWidth(hGrayscale, width);
	if (NFailed(ret))
	{
		printf("NImageGetWidth() failed: %d\n", ret);
		NImageFree(hGrayscale);
		return -1;
	}

	ret = NImageGetPixels(hGrayscale, (void **)image);
	if (NFailed(ret))
	{
		printf("NImageGetPixels() failed: %d\n", ret);
		NImageFree(hGrayscale);
		return -1;
	}

	*hImg = hGrayscale;
	return 0;
}
