#ifndef _FX3_SCAN_H
#define _FX3_SCAN_H

// General defines
#define SOFTWARE_DETECTED		4
#define MANUALLY_STOPPED		5
#define MUTE_SOFTWARE_DETECTED	6

#define USER_CAPTURE 1
#define USER_CANCEL 2

#ifndef FXDLL_LINUX
	// win32
  #ifdef _LIB
		#define FXDLL_EXPORTCALL
	#else
		#define FXDLL_EXPORTCALL __declspec(dllexport)
	#endif
	#define FXDLL_CALLMODE __stdcall
#else
	// linux
	#define FXDLL_EXPORTCALL 
	#define FXDLL_CALLMODE 
#endif // FXOEM_LINUX


FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_InitScanner(VOID);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_ReleaseScanner(VOID);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_GrabFingerprint(
															FINGERPRINT* fing,    // impronta in cui ritorna l'immagine
                              HWND hwnd,            // hwnd della finestra su cui la dialog sar modale (se NULL modale su desktop)
															int x,                // punto di origine su cui plottare la dialog 
															int y,                //   se x o y  negativo centra la dialog sullo schermo 
															int finger_detection, // finger detecting mode
															WORD mincontr,        // minimo contrasto per software auto detection
															PARAM* pP,            // Parametri del metodo necessari per software auto detection  
															float* quality,       // qualit da ritornare
															float delay,          // Delay dopo che il dito  stabile
															float timeout);       // Timeout massimo prima del ritorno

// Funzionalit aggiuntive fxoem
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_StandbyFXOEM(void);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_ResumeFXOEM(void);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_GetFXOEMConfig(BYTE* LiveMode,BYTE* InternalLight,BYTE* RedLed,BYTE* GreenLed);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_SetFXOEMConfig(BYTE* LiveMode,BYTE* InternalLight,BYTE* RedLed,BYTE* GreenLed);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_GetFXOEMPresence(BYTE* Presence);
// Da versione 2.3
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_SetActiveScanner(int ID);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_GetActiveScanner(int* ID);

#ifndef FXDLL_LINUX
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_SetLogonMode(HANDLE hWlx,WLX_DISPATCH_VERSION_1_1* pWlx); // for GINA support
#endif //FXDLL_LINUX

// Callback function per Grab con callback (da versione 2.4)
#ifndef __PGRABCALLBACK
typedef int (*PGRABCALLBACK)(int presence100,int quality100,unsigned char *image,unsigned short ix,unsigned short iy);
#define __PGRABCALLBACK
#endif
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_GrabFingerprintCallBack(
																	FINGERPRINT* fing,    // impronta in cui ritorna l'immagine
           												int finger_detection, // finger detecting mode
															    WORD mincontr,        // minimo contrasto per software auto detection
															    PARAM* pP,            // Parametri del metodo necessari per software auto detection  
															    float* quality,       // qualit da ritornare
															    float delay,          // Delay dopo che il dito  stabile
															    float timeout,
																	PGRABCALLBACK cbFunc);


#define FXOEM_LiveMode_FullImage 1
#define FXOEM_LiveMode_HalfImage 2
#define FXOEM_LiveMode_Blind 3
#define FXOEM_On 1
#define FXOEM_Off 2

// Da versione 2.6
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_SetFXOEMFakeDetection(BYTE LatentCheck,BYTE LivenessCheck);

// Da versione 2.8
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_MOB(WORD MOB_Command, DWORD OutLen, BYTE* SerOutParam, DWORD* InLen, BYTE* SerInParam);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_PKCS11(WORD PKCS11_Command, DWORD OutLen, BYTE* SerOutParam, DWORD* InLen, BYTE* SerInParam,DWORD ExtraTime);

#define TARGET_PC 1
#define TARGET_SCANNER 2

FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_SetAcquisitionTarget(BYTE Target);
FXDLL_EXPORTCALL int FXDLL_CALLMODE FX3SCAN_ForceScannerConnection(BYTE Connection);

// Errori
#define FX3SCAN_OK 0
#define FX3SCAN_Cancel 1  // Returned also by gina
#define FX3SCAN_TimeOut 2
#define FX3SCAN_DllNotFound 10
#define FX3SCAN_CorruptedDll 11
#define FX3SCAN_InitializationFailure 12
#define FX3SCAN_SettingFailure 13
#define FX3SCAN_GrabbingFailure 14
#define FX3SCAN_UnInitializationFailure 15
#define FX3SCAN_ShowError 16
#define FX3SCAN_TimerError 17
#define FX3SCAN_InvalidParameters 18
#define FX3SCAN_NoOnlineCapability 20
#define FX3SCAN_InvalidFingerprintImage 21
#define FX3SCAN_InvalidLatent 22
#define FX3SCAN_InvalidLiveness 23
#define FX3SCAN_FeatureNotAvailable 24

#endif //_FX3_SCAN_H